#include "Arduino.h"
#include "SoftwareSerial.h"
#include "DFRobotDFPlayerMini.h"

//---------------------------------------------------------------------------------
//      Áudio
//---------------------------------------------------------------------------------

//Inicia a serial por software nos pinos 10 e 11
SoftwareSerial mySoftwareSerial(10, 11); // RX, TX

DFRobotDFPlayerMini myDFPlayer;

char buf;
int pausa = 0;
int equalizacao = 0;

int resultado = 0;
int audioSelecionado = 0;
int perguntaSelecionada = 0;

int botao1 = 2;
int botao2 = 3;
int botao3 = 4;
int botao4 = 5;

bool estaTocandoDomestico;
bool estaTocandoSilvestre;
bool primeiraVezDomestico;
bool primeiraVezSilvestre;
  
// setup (executado apenas uma vez)
void setup() {

  pinMode(botao1, INPUT);
  pinMode(botao2, INPUT);
  pinMode(botao3, INPUT);  
  pinMode(botao4, INPUT);

  //-------------------------------------------------------
  //  define Audio
  //-------------------------------------------------------
  mySoftwareSerial.begin(9600);
  myDFPlayer.begin(mySoftwareSerial); //inicia módulo MP3, essa linha ficava dentro da Serial
  
  myDFPlayer.setTimeOut(500); //Timeout serial 500ms
  myDFPlayer.volume(30); 
  myDFPlayer.EQ(0); //Equalizacao normal  

  resultado = myDFPlayer.readFileCounts();  

  Serial.begin(9600);
  
}
 
// laço principal (executado indefinidamente)
void loop() {  

    //SORTEIO ANIMAIS DOMÉSTICOS - ÁUDIOS 1 A 7
    if (digitalRead(botao1) == HIGH) {
    
      primeiraVezDomestico = true;
      
      Serial.println("botão 1");

      audioSelecionado = random(1, 7);
    
      Serial.println(audioSelecionado);
      
      myDFPlayer.play(audioSelecionado);

      delay (1000);
    }    

    //SORTEIO ANIMAIS SILVESTRES - ÁUDIOS 13 A 18
    if (digitalRead(botao3) == HIGH) {

      primeiraVezSilvestre = true;

      Serial.println("botão 2");

      audioSelecionado = random(13, 19);
    
      Serial.println(audioSelecionado);
      
      myDFPlayer.play(audioSelecionado);

      delay (1000);
    }

    //EXECUTAR ÁUDIOS DOS ANIMAIS DOMÉSTICOS
    //se áudio 1 - toca 7
    //se áudio 2 - toca 8
    //se áudio 3 - toca 9
    //se áudio 4 - toca 10
    //se áudio 5 - toca 11
    //se áudio 6 - toca 12
    
    if (digitalRead(botao2) == HIGH) {
      
      Serial.println("botão 3");

      if (primeiraVezDomestico == true){
        
        if (audioSelecionado == 1){
          myDFPlayer.play(7);
          primeiraVezDomestico = false;
          estaTocandoDomestico = false;
          primeiraVezSilvestre = true;
        }
        else if (audioSelecionado == 2){
          myDFPlayer.play(8);
          primeiraVezDomestico = false;
          estaTocandoDomestico = false;
          primeiraVezSilvestre = true;
        }
        else if (audioSelecionado == 3){
          myDFPlayer.play(9);
          primeiraVezDomestico = false;
          estaTocandoDomestico = false;
          primeiraVezSilvestre = true;
        }        
        else if (audioSelecionado == 4){
          myDFPlayer.play(10);
          primeiraVezDomestico = false;
          estaTocandoDomestico = false;
          primeiraVezSilvestre = true;
        }        
        else if (audioSelecionado == 5){
          myDFPlayer.play(11);
          primeiraVezDomestico = false;
          estaTocandoDomestico = false;
          primeiraVezSilvestre = true;
        }
        else if (audioSelecionado == 6){
          myDFPlayer.play(12);
          primeiraVezDomestico = false;
          estaTocandoDomestico = false;
          primeiraVezSilvestre = true;
        }           
      }
        
      else{
        if (estaTocandoDomestico == true){
          Serial.println("tocando");
          myDFPlayer.pause();
          estaTocandoDomestico = false;
          delay (1000);
        }
        else if (estaTocandoDomestico == false){
          Serial.println("pausado");
          myDFPlayer.start();
          estaTocandoDomestico = true;
          delay (1000);
        }              
      }    
    }    

    //EXECUTAR ÁUDIOS DOS ANIMAIS SILVESTRES
    //se áudio 13 - toca 19
    //se áudio 14 - toca 20
    //se áudio 15 - toca 21
    //se áudio 16 - toca 22
    //se áudio 17 - toca 23
    //se áudio 18 - toca 24
    
    if (digitalRead(botao4) == HIGH) {

      Serial.println("botão 4");

      if (primeiraVezSilvestre == true){
        
        if (audioSelecionado == 13){
          myDFPlayer.play(19);
          primeiraVezSilvestre = false;
          estaTocandoSilvestre = false;
          primeiraVezDomestico = true;
        }
        else if (audioSelecionado == 14){
          myDFPlayer.play(20);
          primeiraVezSilvestre = false;
          estaTocandoSilvestre = false;
          primeiraVezDomestico = true;
        }
        else if (audioSelecionado == 15){
          myDFPlayer.play(21);
          primeiraVezSilvestre = false;
          estaTocandoSilvestre = false;
          primeiraVezDomestico = true;
        }        
        else if (audioSelecionado == 16){
          myDFPlayer.play(22);
          primeiraVezSilvestre = false;
          estaTocandoSilvestre = false;
          primeiraVezDomestico = true;
        }        
        else if (audioSelecionado == 17){
          myDFPlayer.play(23);
          primeiraVezSilvestre = false;
          estaTocandoSilvestre = false;
          primeiraVezDomestico = true;
        }
        else if (audioSelecionado == 18){
          myDFPlayer.play(24);
          primeiraVezSilvestre = false;
          estaTocandoSilvestre = false;
          primeiraVezDomestico = true;
        }           
      }
        
      else{
        if (estaTocandoSilvestre == true){
          Serial.println("tocando");
          myDFPlayer.pause();
          estaTocandoSilvestre = false;
          delay (1000);
        }
        else if (estaTocandoSilvestre == false){
          Serial.println("pausado");
          myDFPlayer.start();
          estaTocandoSilvestre = true;
          delay (1000);
        }              
      }    
    }    

  delay(100);

}
